﻿using GrapeCity.Windows.SpreadSheet.Data;
using GrapeCity.Windows.SpreadSheet.UI;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace SilverlightApplication1
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
            this.spread1.ActiveSheet.SetColumnWidth(0, SheetArea.Cells, 120);
            this.spread1.ActiveSheet.SetRowHeight(0, SheetArea.Cells, 120);
            this.spread1.ActiveSheet.SetActiveCell(1, 1);
            this.spread1.ActiveSheet.SetText(0, 0, "学生姓名,分数,科目");

            DrawingObjectManager.SetDrawingObjectProvider(this.spread1, new MyDrawingObjectProvider());
        }
    }

    internal class MyDrawingObjectProvider : IDrawingObjectProvider
    {
        public DrawingObject[] GetDrawingObjects(Worksheet sheet, int row, int column, int rowCount, int columnCount)
        {
            if (row == 0 && column == 0)
            {
                DiagonalDrawingObject dobj = new DiagonalDrawingObject(sheet, row, column);
                return new DrawingObject[] { dobj };
            }
            return sheet.GetDrawingObject(row, column, rowCount, columnCount);
        }
    }

    internal class DiagonalDrawingObject : CustomDrawingObject
    {
        public DiagonalDrawingObject(Worksheet worksheet, int row, int col) :
            base(row, col)
        {
            this.Worksheet = worksheet;
            this.ShowDrawingObjectOnly = true;
        }

        private Worksheet Worksheet { get; set; }

        public override FrameworkElement RootElement
        {
            get
            {
                string cellText = this.Worksheet.GetText(this.AnchorRow, this.AnchorColumn);
                string[] values = null;
                if (!string.IsNullOrEmpty(cellText))
                {
                    values = cellText.Split(',');
                }

                double width = this.Worksheet.GetColumnWidth(this.AnchorColumn);
                double height = this.Worksheet.GetRowHeight(this.AnchorRow);

                Brush cellForeground = this.Worksheet.Cells[this.AnchorRow, this.AnchorColumn].ActualForeground;
                if (cellForeground == null)
                {
                    cellForeground = new SolidColorBrush(Colors.Black);
                }

                Canvas canvas = new Canvas();

                Line diagonalLine1 = new Line();
                diagonalLine1.Stroke = cellForeground;
                diagonalLine1.StrokeThickness = 1;
                diagonalLine1.X1 = 0;
                diagonalLine1.Y1 = height / 3;
                diagonalLine1.X2 = width;
                diagonalLine1.Y2 = height;

                Line diagonalLine2 = new Line();
                diagonalLine2.Stroke = cellForeground;
                diagonalLine2.StrokeThickness = 1;
                diagonalLine2.X1 = width / 3;
                diagonalLine2.Y1 = 0;
                diagonalLine2.X2 = width;
                diagonalLine2.Y2 = height;

                canvas.Children.Add(diagonalLine1);
                canvas.Children.Add(diagonalLine2);

                if (values != null)
                {
                    if (values.Length > 0)
                    {
                        string text1 = values[0];
                        TextBlock t1 = new TextBlock();
                        t1.Text = text1;
                        //t1.RenderTransform = new RotateTransform(30, 0.5, 0.5);
                        Canvas.SetLeft(t1, 10);
                        Canvas.SetTop(t1, height - 30);

                        canvas.Children.Add(t1);
                    }

                    if (values.Length > 1)
                    {
                        string text2 = values[1];
                        TextBlock t2 = new TextBlock();
                        t2.Text = text2;
                        //t2.RenderTransform = new RotateTransform(30, 0.5, 0.5);
                        Canvas.SetLeft(t2, 40);
                        Canvas.SetTop(t2, height / 3);

                        canvas.Children.Add(t2);
                    }

                    if (values.Length > 2)
                    {
                        string text3 = values[2];
                        TextBlock t3 = new TextBlock();
                        t3.Text = text3;
                        //t3.RenderTransform = new RotateTransform(50, 0.5, 0.5);
                        Canvas.SetLeft(t3, 3 * (width / 5));
                        Canvas.SetTop(t3, 10);

                        canvas.Children.Add(t3);
                    }
                }

                return canvas;
            }
        }
    }
}
